<?php

namespace WEBprofil\TemplavoilaConverter\Controller;

/* * *************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016 Gernot Ploiner <gp@webprofil.at>, WEBprofil - Gernot Ploiner e.U.
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * ConverterController
 */
class ConverterController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController {

    /**
     * action create
     *
     * @return void
     */
    public function createAction() {
        $port = $GLOBALS['TYPO3_CONF_VARS']['DB']['port'];
        $tables = 'tx_templavoila_datastructure tx_templavoila_tmplobj pages pages_language_overlay tt_content sys_file sys_language backend_layout';
        $filename = PATH_site . 'typo3temp/backup.zip';

        $command = 'mysqldump -h ' . TYPO3_db_host . ' -u ' . TYPO3_db_username . '  --port=' . $port . ' --password=' . TYPO3_db_password . ' ' . TYPO3_db . ' ' . $tables . ' | zip > ' . $filename;
        system($command, $error);
        /*
        if($error === 0) {
            $msg = 'Backup generated successfully in folder: ' . $filename;
        } else {
            $msg = 'ERROR: ' . $error . '. Are you sure this database has the templavoila tables?';
        }
        */
        $this->redirect('show');
    }

    /**
     * action delete
     *
     * @return void
     */
    public function deleteAction() {
        $filename = PATH_site . 'typo3temp/backup.zip';
        unlink($filename);
        $this->redirect('show');
    }

    /**
     * action show
     *
     * @return void
     */
    public function showAction() {
        $fileExits = $this->checkFileExists();
        $tableInfos = $this->getTableInfos();
        
        $this->view->assign('fileExits', $fileExits);
        $this->view->assign('tableInfos', $tableInfos);
    }

    /**
     * loadTableInfo
     *
     * @return void
     */
    private function loadTableInfo($table) {
        $res = $GLOBALS['TYPO3_DB']->sql_query('SHOW COLUMNS FROM ' . $table . ' LIKE "deleted"');
        $deletedEexists = $res->num_rows;
        if ($deletedEexists == 1) {
            $res = $GLOBALS['TYPO3_DB']->exec_SELECTquery("COUNT(*) AS count", $table, 'deleted=0');
            $data['active'] = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
            $res = $GLOBALS['TYPO3_DB']->exec_SELECTquery("COUNT(*) AS count", $table, 'deleted=1');
            $data['deleted'] = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
        }
        $res = $GLOBALS['TYPO3_DB']->exec_SELECTquery("COUNT(*) AS count", $table, '');
        $data['total'] = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
        return $data;
    }
    
    /**
     * checkTableExist
     *
     * @return void
     */
    private function checkTableExist($table) {
        $res = $GLOBALS['TYPO3_DB']->sql_query('SHOW TABLES LIKE "' . $table . '"');
        return $res->num_rows;
    }
    
    /**
     * getTableInfos
     *
     * @return void
     */
    private function getTableInfos() {
        $tables = array('backend_layout', 'pages', 'pages_language_overlay', 'sys_language', 'sys_file', 'tt_content', 'tx_templavoila_datastructure', 'tx_templavoila_tmplobj');
        foreach ($tables as $table) {
            $tableExist = $this->checkTableExist($table);
            if ($tableExist == 1) {
                $tableInfos['data'][$table] = $this->loadTableInfo($table);
            } else {
                $tableInfos['missing'][$table] = $table;
                $tableInfos['data'][$table]['total']['count'] = 'missing';
            }
        }
        return $tableInfos;
    }
    
    /**
     * checkFileExists
     *
     * @return void
     */
    private function checkFileExists() {
        $filename = PATH_site . 'typo3temp/backup.zip';
        if (file_exists($filename)) {
            return true;
        } else {
            return false;
        }
    }
    
}
